<?php

defined('_VALID_CALL') or die('Direct Access is not allowed.');

unset($status);
unset($capture);

$kco_order = json_decode($_data['order_data']['kco_order_data'], true);

$tmp_data['kco_order_status_overview'] = array();
if(is_array($kco_order))
{
    global $price;

    $amount = $price->_StyleFormat($kco_order["original_order_amount"]/100);

    $status = array(
        'icon' => 'circle',
        'style' => 'solid',
        'color' => '#649268',
        'size' => 'sm',
        'cssClass' => '',
        'tooltip' => constant('TEXT_KLARNA_KCO_ACCEPTED') ?: 'Accepted '.$amount
    );

    $canceled = false;
    $captured = false;
    $refunded = false;

    // cancelled
    if ($_data['order_data']['kco_order_status'] == 'CANCELLED')
    {
        $canceled = array(
            'icon' => 'ban',
            'style' => 'solid',
            'size' => 'sm',
            'cssClass' => '',
            'tooltip' => constant('TEXT_KLARNA_KCO_CANCELED') ?: 'Canceled'
        );
    }

    // fraud status
    if ($_data['order_data']['kco_order_fraud_status'] != 'ACCEPTED')
    {
        if ($_data['order_data']['kco_order_fraud_status'] == 'PENDING')
        {
            $status['color'] = 'orange';
            $status['tooltip'] = constant('TEXT_KLARNA_KCO_PENDING') ?: 'Pending';
        }
        else if ($_data['order_data']['kco_order_fraud_status'] == 'REJECTED')
        {

            $status['color'] = 'red';
            $status['tooltip'] = constant('TEXT_KLARNA_KCO_REJECTED') ?: 'Rejected';
        }

    }
    else {
        // capture
        if($_data["order_data"]["orders_id"] == "126")
        {
            $a = 0;
        }
        if($kco_order["captured_amount"] > 0)
        {
            $amount = $price->_StyleFormat($kco_order["captured_amount"]/100);
            $captured = array(
                'icon' => 'circle',
                'style' => 'solid',
                'size' => 'sm',
                'tooltip' => constant('TEXT_KLARNA_KCO_CAPTURED_FULL') ?: 'Full captured '.$amount
            );
            if ($kco_order["remaining_authorized_amount"] > 0)
            {
                $captured['style'] = 'regular';
                $captured['tooltip'] = constant('TEXT_KLARNA_KCO_CAPTURED_PART') ?: 'Part captured '.$amount;
            }

            // refunded
            if($kco_order["refunded_amount"] > 0)
            {
                $amount = $price->_StyleFormat($kco_order["refunded_amount"]/100);
                $refunded = array(
                    'icon' => 'circle',
                    'style' => 'solid',
                    'size' => 'sm',
                    'tooltip' => constant('TEXT_KLARNA_KCO_REFUNDED_FULL') ?: 'Full refunded '.$amount
                );
                if ($kco_order["refunded_amount"] < $kco_order["captured_amount"])
                {
                    $refunded['style'] = 'regular';
                    $refunded['tooltip'] = constant('TEXT_KLARNA_KCO_REFUNDED_PART') ?: 'Part refunded '.$amount;
                }

                // refunded
            }

        }

    }



    $tmp_data['kco_order_status_overview'] = array(
        $status
    );
    if($canceled)
    {
        $tmp_data['kco_order_status_overview'][] = $canceled;
    }
    else if($captured)
    {
        $tmp_data['kco_order_status_overview'][] = $captured;

        if($refunded)
        {
            $tmp_data['kco_order_status_overview'][] = $refunded;
        }
    }
}
